# TileCoordinatesImageryProvider

#### new Cesium.TileCoordinatesImageryProvider(options)
Scene/TileCoordinatesImageryProvider.js 37

  An `ImageryProvider` that draws a box around every rendered tile in the tiling scheme, and draws a label inside it indicating the X, Y, Level coordinates of the tile. This is mostly useful for debugging terrain and imagery rendering problems.

  Name | Type | Description
  --- | --- | ---

  `options`

  Object

  optional Object with the following properties:

  Name | Type | Default | Description
  --- | --- | --- | ---
  `tilingScheme` | TilingScheme | `new GeographicTilingScheme()` | optional The tiling scheme for which to draw tiles.
  `ellipsoid` | Ellipsoid |  | optional The ellipsoid. If the tilingScheme is specified, this parameter is ignored and the tiling scheme's ellipsoid is used instead. If neither parameter is specified, the WGS84 ellipsoid is used.
  `color` | Color | `Color.YELLOW` | optional The color to draw the tile box and label.
  `tileWidth` | Number | `256` | optional The width of the tile for level-of-detail selection purposes.
  `tileHeight` | Number | `256` | optional The height of the tile for level-of-detail selection purposes.

### Members

#### readonlycredit : Credit
Scene/TileCoordinatesImageryProvider.js 199

  Gets the credit to display when this imagery provider is active. Typically this is used to credit the source of the imagery. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlyerrorEvent : Event
Scene/TileCoordinatesImageryProvider.js 162

  Gets an event that is raised when the imagery provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonlyhasAlphaChannel : Boolean
Scene/TileCoordinatesImageryProvider.js 215

  Gets a value indicating whether or not the images provided by this imagery provider include an alpha channel. If this property is false, an alpha channel, if present, will be ignored. If this property is true, any images without an alpha channel will be treated as if their alpha is 1.0 everywhere. Setting this property to false reduces memory usage and texture upload time.

#### readonlymaximumLevel : Number
Scene/TileCoordinatesImageryProvider.js 94

  Gets the maximum level-of-detail that can be requested. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlyminimumLevel : Number
Scene/TileCoordinatesImageryProvider.js 107

  Gets the minimum level-of-detail that can be requested. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlyproxy : Proxy
Scene/TileCoordinatesImageryProvider.js 55

  Gets the proxy used by this provider.

#### readonlyready : Boolean
Scene/TileCoordinatesImageryProvider.js 174

  Gets a value indicating whether or not the provider is ready for use.

#### readonlyreadyPromise : Promise.<Boolean>
Scene/TileCoordinatesImageryProvider.js 186

  Gets a promise that resolves to true when the provider is ready for use.

#### readonlyrectangle : Rectangle
Scene/TileCoordinatesImageryProvider.js 133

  Gets the rectangle, in radians, of the imagery provided by this instance. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlytileDiscardPolicy : TileDiscardPolicy
Scene/TileCoordinatesImageryProvider.js 148

  Gets the tile discard policy. If not undefined, the discard policy is responsible for filtering out "missing" tiles via its shouldDiscardImage function. If this function returns undefined, no tiles are filtered. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlytileHeight : Number
Scene/TileCoordinatesImageryProvider.js 81

  Gets the height of each tile, in pixels. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlytileWidth : Number
Scene/TileCoordinatesImageryProvider.js 68

  Gets the width of each tile, in pixels. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

#### readonlytilingScheme : TilingScheme
Scene/TileCoordinatesImageryProvider.js 120

  Gets the tiling scheme used by this provider. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

### Methods

#### getTileCredits(x, y, level) → Array.<Credit>
Scene/TileCoordinatesImageryProvider.js 232

  Gets the credits to be displayed when a given tile is displayed.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level;

  ##### Returns:

  The credits to be displayed when the tile is displayed.

  ##### Throws:

  - DeveloperError : `getTileCredits` must not be called before the imagery provider is ready.

#### pickFeatures(x, y, level, longitude, latitude) → Promise.<Array.<ImageryLayerFeatureInfo>>|undefined
Scene/TileCoordinatesImageryProvider.js 285

  Picking features is not currently supported by this imagery provider, so this function simply returns undefined.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.
  `longitude` | Number | The longitude at which to pick features.
  `latitude` | Number | The latitude at which to pick features.

  ##### Returns:

  A promise for the picked features that will resolve when the asynchronous picking completes. The resolved value is an array of `ImageryLayerFeatureInfo` instances. The array may be empty if no features are found at the given location. It may also be undefined if picking is not supported.

#### requestImage(x, y, level) → Promise.<(Image|Canvas)>|undefined
Scene/TileCoordinatesImageryProvider.js 248

  Requests the image for a given tile. This function should not be called before `TileCoordinatesImageryProvider#ready` returns true.

  Name | Type | Description
  --- | --- | ---
  `x` | Number | The tile X coordinate.
  `y` | Number | The tile Y coordinate.
  `level` | Number | The tile level.

  ##### Returns:

  A promise for the image that will resolve when the image is available, or undefined if there are too many active requests to the server, and the request should be retried later. The resolved image may be either an Image or a Canvas DOM object.